.\" $NetBSD: wcsrtombs.3,v 1.11 2006/10/14 07:51:01 wiz Exp $
.\"
.\" Copyright (c)2002 Citrus Project,
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd August 8, 2006
.Dt WCSRTOMBS 3
.Os
.\" ----------------------------------------------------------------------
.Sh NAME
.Nm wcsrtombs
.Nd converts a wide character string to a multibyte character string \
(restartable)
.\" ----------------------------------------------------------------------
.Sh LIBRARY
.Lb libc
.\" ----------------------------------------------------------------------
.Sh SYNOPSIS
.In wchar.h
.Ft size_t
.Fn wcsrtombs "char * restrict s" "const wchar_t ** restrict pwcs" \
"size_t n" "mbstate_t * restrict ps"
.\" ----------------------------------------------------------------------
.Sh DESCRIPTION
The
.Fn wcsrtombs
converts the nul-terminated wide character string indirectly pointed
to by
.Fa pwcs
to the corresponding multibyte character string,
and stores it in the array pointed to by
.Fa s .
The conversion stops due to the following reasons:
.Bl -bullet
.It
The conversion reaches a nul wide character.
In this case, the nul wide character is also converted.
.It
The
.Fn wcsrtombs
has already stored
.Fa n
bytes in the array pointed to by
.Fa s .
.It
The conversion encounters an invalid character.
.El
.Pp
Each character will be converted as if
.Xr wcrtomb 3
is continuously called, except the internal state of
.Xr wcrtomb 3
will not be affected.
.Pp
After conversion,
if
.Fa s
is not a null pointer, the pointer object pointed to by
.Fa pwcs
is a null pointer (if the conversion is stopped due to reaching a
nul wide character) or the first byte of the character just after
the last character converted.
.Pp
If
.Fa s
is not a null pointer and the conversion is stopped due to reaching
a nul wide character,
.Fn wcsrtombs
places the state object pointed to by
.Fa ps
to an initial state after the conversion is taken place.
.Pp
The behaviour of
.Fn wcsrtombs
is affected by the
.Dv LC_CTYPE
category of the current locale.
.Pp
These are the special cases:
.Bl -tag -width 012345678901
.It "s == NULL"
.Fn wcsrtombs
returns the number of bytes to store the whole multibyte character string
corresponding to the wide character string pointed to by
.Fa pwcs ,
not including the terminating nul byte.
In this case,
.Fa n
is ignored.
.It "pwcs == NULL || *pwcs == NULL"
Undefined (may cause the program to crash).
.It "ps == NULL"
.Fn wcsrtombs
uses its own internal state object to keep the conversion state,
instead of
.Fa ps
mentioned in this manual page.
.Pp
Calling any other functions in
.Lb libc
never changes the internal
state of
.Fn wcsrtombs ,
which is initialized at startup time of the program.
.El
.\" ----------------------------------------------------------------------
.Sh RETURN VALUES
.Fn wcsrtombs
returns:
.Bl -tag -width 012345678901
.It 0 or positive
Number of bytes stored in the array pointed to by
.Fa s ,
except for a nul byte.
There are no cases that the value returned is greater than
.Fa n
(unless
.Fa s
is a null pointer).
If the return value is equal to
.Fa n ,
the string pointed to by
.Fa s
will not be nul-terminated.
.It (size_t)-1
.Fa pwcs
points to a string containing an invalid wide character.
The
.Fn wcsrtombs
also sets
.Va errno
to indicate the error.
.El
.\" ----------------------------------------------------------------------
.Sh ERRORS
.Fn wcsrtombs
may cause an error in the following case:
.Bl -tag -width Er
.It Bq Er EILSEQ
.Fa pwcs
points to a string containing an invalid wide character.
.El
.\" ----------------------------------------------------------------------
.Sh SEE ALSO
.Xr setlocale 3 ,
.Xr wcrtomb 3 ,
.Xr wcstombs 3
.\" ----------------------------------------------------------------------
.Sh STANDARDS
The
.Fn wcsrtombs
function conforms to
.St -ansiC .
The restrict qualifier is added at
.St -isoC-99 .
